/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2013-08-07 12:03:19,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.rest.model;

/**
 * Details about the requested item, that should be useful in
 * finding how the item was retrieved.
 *       
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
@com.thoughtworks.xstream.annotations.XStreamAlias( value = "artifact-info-resource" )
@javax.xml.bind.annotation.XmlType( name = "artifact-info-resource" )
@javax.xml.bind.annotation.XmlAccessorType(javax.xml.bind.annotation.XmlAccessType.FIELD)
        
public class ArtifactInfoResource
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The flag that marks item as locally present (hosted/cached).
     */
    private boolean presentLocally = false;

    /**
     * The repository where the artifact is stored.
     */
    private String repositoryId;

    /**
     * The repository name where the artifact is stored.
     */
    private String repositoryName;

    /**
     * The path in repository where the artifact is stored.
     */
    private String repositoryPath;

    /**
     * The MIME type of the artifact.
     */
    private String mimeType;

    /**
     * User id that uploaded the artifact.
     */
    private String uploader;

    /**
     * When the artifact was uploaded.
     */
    private long uploaded = 0L;

    /**
     * When the artifact was changed for the last time.
     */
    private long lastChanged = 0L;

    /**
     * Artifact size on disk.
     */
    private long size = 0L;

    /**
     * Sha1 Hash.
     */
    private String sha1Hash;

    /**
     * Md5 Hash.
     */
    private String md5Hash;

    /**
     * Field repositories.
     */
    @javax.xml.bind.annotation.XmlElementWrapper( name = "data" )
    @javax.xml.bind.annotation.XmlElement( name = "repositories" )
    private java.util.List<RepositoryUrlResource> repositories;

    /**
     * Informs if current user has what is needed to delete this
     * artifact.
     */
    private boolean canDelete = false;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addRepository.
     * 
     * @param repositoryUrlResource
     */
    public void addRepository( RepositoryUrlResource repositoryUrlResource )
    {
        getRepositories().add( repositoryUrlResource );
    } //-- void addRepository( RepositoryUrlResource )

    /**
     * Get when the artifact was changed for the last time.
     * 
     * @return long
     */
    public long getLastChanged()
    {
        return this.lastChanged;
    } //-- long getLastChanged()

    /**
     * Get md5 Hash.
     * 
     * @return String
     */
    public String getMd5Hash()
    {
        return this.md5Hash;
    } //-- String getMd5Hash()

    /**
     * Get the MIME type of the artifact.
     * 
     * @return String
     */
    public String getMimeType()
    {
        return this.mimeType;
    } //-- String getMimeType()

    /**
     * Method getRepositories.
     * 
     * @return List
     */
    public java.util.List<RepositoryUrlResource> getRepositories()
    {
        if ( this.repositories == null )
        {
            this.repositories = new java.util.ArrayList<RepositoryUrlResource>();
        }

        return this.repositories;
    } //-- java.util.List<RepositoryUrlResource> getRepositories()

    /**
     * Get the repository where the artifact is stored.
     * 
     * @return String
     */
    public String getRepositoryId()
    {
        return this.repositoryId;
    } //-- String getRepositoryId()

    /**
     * Get the repository name where the artifact is stored.
     * 
     * @return String
     */
    public String getRepositoryName()
    {
        return this.repositoryName;
    } //-- String getRepositoryName()

    /**
     * Get the path in repository where the artifact is stored.
     * 
     * @return String
     */
    public String getRepositoryPath()
    {
        return this.repositoryPath;
    } //-- String getRepositoryPath()

    /**
     * Get sha1 Hash.
     * 
     * @return String
     */
    public String getSha1Hash()
    {
        return this.sha1Hash;
    } //-- String getSha1Hash()

    /**
     * Get artifact size on disk.
     * 
     * @return long
     */
    public long getSize()
    {
        return this.size;
    } //-- long getSize()

    /**
     * Get when the artifact was uploaded.
     * 
     * @return long
     */
    public long getUploaded()
    {
        return this.uploaded;
    } //-- long getUploaded()

    /**
     * Get user id that uploaded the artifact.
     * 
     * @return String
     */
    public String getUploader()
    {
        return this.uploader;
    } //-- String getUploader()

    /**
     * Get informs if current user has what is needed to delete
     * this artifact.
     * 
     * @return boolean
     */
    public boolean isCanDelete()
    {
        return this.canDelete;
    } //-- boolean isCanDelete()

    /**
     * Get the flag that marks item as locally present
     * (hosted/cached).
     * 
     * @return boolean
     */
    public boolean isPresentLocally()
    {
        return this.presentLocally;
    } //-- boolean isPresentLocally()

    /**
     * Method removeRepository.
     * 
     * @param repositoryUrlResource
     */
    public void removeRepository( RepositoryUrlResource repositoryUrlResource )
    {
        getRepositories().remove( repositoryUrlResource );
    } //-- void removeRepository( RepositoryUrlResource )

    /**
     * Set informs if current user has what is needed to delete
     * this artifact.
     * 
     * @param canDelete
     */
    public void setCanDelete( boolean canDelete )
    {
        this.canDelete = canDelete;
    } //-- void setCanDelete( boolean )

    /**
     * Set when the artifact was changed for the last time.
     * 
     * @param lastChanged
     */
    public void setLastChanged( long lastChanged )
    {
        this.lastChanged = lastChanged;
    } //-- void setLastChanged( long )

    /**
     * Set md5 Hash.
     * 
     * @param md5Hash
     */
    public void setMd5Hash( String md5Hash )
    {
        this.md5Hash = md5Hash;
    } //-- void setMd5Hash( String )

    /**
     * Set the MIME type of the artifact.
     * 
     * @param mimeType
     */
    public void setMimeType( String mimeType )
    {
        this.mimeType = mimeType;
    } //-- void setMimeType( String )

    /**
     * Set the flag that marks item as locally present
     * (hosted/cached).
     * 
     * @param presentLocally
     */
    public void setPresentLocally( boolean presentLocally )
    {
        this.presentLocally = presentLocally;
    } //-- void setPresentLocally( boolean )

    /**
     * Set the repositories list containing the artifact.
     * 
     * @param repositories
     */
    public void setRepositories( java.util.List<RepositoryUrlResource> repositories )
    {
        this.repositories = repositories;
    } //-- void setRepositories( java.util.List )

    /**
     * Set the repository where the artifact is stored.
     * 
     * @param repositoryId
     */
    public void setRepositoryId( String repositoryId )
    {
        this.repositoryId = repositoryId;
    } //-- void setRepositoryId( String )

    /**
     * Set the repository name where the artifact is stored.
     * 
     * @param repositoryName
     */
    public void setRepositoryName( String repositoryName )
    {
        this.repositoryName = repositoryName;
    } //-- void setRepositoryName( String )

    /**
     * Set the path in repository where the artifact is stored.
     * 
     * @param repositoryPath
     */
    public void setRepositoryPath( String repositoryPath )
    {
        this.repositoryPath = repositoryPath;
    } //-- void setRepositoryPath( String )

    /**
     * Set sha1 Hash.
     * 
     * @param sha1Hash
     */
    public void setSha1Hash( String sha1Hash )
    {
        this.sha1Hash = sha1Hash;
    } //-- void setSha1Hash( String )

    /**
     * Set artifact size on disk.
     * 
     * @param size
     */
    public void setSize( long size )
    {
        this.size = size;
    } //-- void setSize( long )

    /**
     * Set when the artifact was uploaded.
     * 
     * @param uploaded
     */
    public void setUploaded( long uploaded )
    {
        this.uploaded = uploaded;
    } //-- void setUploaded( long )

    /**
     * Set user id that uploaded the artifact.
     * 
     * @param uploader
     */
    public void setUploader( String uploader )
    {
        this.uploader = uploader;
    } //-- void setUploader( String )

}
